
#ifndef _SMS_H_
#define _SMS_H_

/* SMS context */
typedef struct
{
    byte dummy[0x2000];
    byte ram[0x2000];
    byte sram[0x8000];
    byte *write_map[8];
    byte *read_map[8];
    byte fcr[4];
    byte paused;
    byte save;
}t_sms;

/* Global data */
extern t_sms sms;

/* Function prototypes */
void sms_frame(int skip_render);
void sms_init(void);
void sms_reset(void);
int irq_callback(int param);
void sms_mapper_w(int address, int data);
int cpu_readmem16(int address);
void cpu_writemem16(int address, int data);
int cpu_readop(int address);
int cpu_readop_arg(int address);
void change_pc16(int pc);
void change_pc(int pc);

#endif /* _SMS_H_ */
